// $Id: assistant_ref.form.js,v 1.1 2010/03/09 16:56:51 pounard Exp $

/**
 * @file
 * Nice behaviors for node edit form.
 */

(function ($) {

Drupal.behaviors.AssistantRefNodeForm = function(context) {
  $('.assistant-ref-enabled', context).each(function(){
    if (! $(this).is('.assistant-ref-enabled-processed')) {
      var fieldName = this.id.substr("assistant-ref-enabled-".length);
      new Drupal.AssistantRefNodeForm(fieldName);
      $(this).addClass('assistant-ref-enabled-processed');
    }
  });
};

Drupal.AssistantRefNodeForm = function(fieldName) {
  // Self reference to keep object in scope in anonymous callbacks
  var self = this;
  this.fieldName = fieldName;

  // Init
  this.toggle(! $('#assistant-ref-enabled-' + this.fieldName).is(":checked"));

  // Add jQueryUI behaviors if jQueryUI is present
  $('#assistant-ref-enabled-' + self.fieldName).change(function(){
    self.toggle(! $(this).is(":checked"));
  });
};

/**
 * Toggle select and hidden preset inputs
 * @param boolean toggle
 *   true for disabling, false for enabling
 */
Drupal.AssistantRefNodeForm.prototype.toggle = function(toggle) {
  if (toggle != undefined) {
    $('#assistant-ref-presets-' + this.fieldName + ' input').attr('disabled', toggle);
    $('#assistant-ref-presets-' + this.fieldName + ' select').attr('disabled', toggle);
    // This should never have been added.
    // $('#edit-' + this.fieldName + '-edit').attr('disabled', toggle);
  }
};

})(jQuery);
